Need MemoryStick driver Ricoh R5C592 (part of R5C832/822chipset)

Bug #238208 reported by Matthew Woerly on 2008-06-07
534
This bug affects 95 people
Affects Status Importance Assigned to Milestone
openSUSE
New
Undecided
Unassigned
linux (Ubuntu)
Wishlist
Tim Gardner
Declined for Intrepid by Brad Figg
Declined for Jaunty by Brad Figg
Declined for Karmic by Brad Figg
Oneiric
Undecided
Tim Gardner
Precise
Wishlist
Tim Gardner

Bug Description

*** NOTE: this is a *wishlist* item - a request for new functionality. This issue is a request to have MemoryStick support added for a specific, and somewhat popular, chipset. Please do not add "me, too" items. We know that it doesn't work. If you want, please add yourself as a subscriber, and click on link to indicate that "This bug effects me, too"

You are welcome to test the new developed drivers at

http://gitorious.org/ricoh-kernel

You can download them ether by doing (preferred):
git clone git://gitorious.org/ricoh-kernel/ricoh-kernel.git

Then you can receive updates using
git pull

or you can press on 'Source tree' and download a snapshot by pressing 'Download master as tar.gz'

XD support is also done and merged in 2.6.35 (backport in above tree)

------------------------------------------------

Running 2.6.24-18, in Hardy

02:09.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller (rev 05) (prog-if 10 [OHCI])
 Subsystem: Dell Unknown device 022f
 Flags: bus master, medium devsel, latency 64, IRQ 16
 Memory at fe3ff800 (32-bit, non-prefetchable) [size=2K]
 Capabilities: <access denied>

02:09.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22) (prog-if 01)
 Subsystem: Dell Unknown device 022f
 Flags: medium devsel, IRQ 18
 Memory at fe3ff400 (32-bit, non-prefetchable) [size=256]
 Capabilities: <access denied>

02:09.2 System peripheral: Ricoh Co Ltd R5C843 MMC Host Controller (rev 12)
 Subsystem: Dell Unknown device 022f
 Flags: bus master, medium devsel, latency 64, IRQ 5
 Memory at fe3ff500 (32-bit, non-prefetchable) [size=256]
 Capabilities: <access denied>

02:09.3 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)
 Subsystem: Dell Unknown device 022f
 Flags: bus master, medium devsel, latency 64, IRQ 5
 Memory at fe3ff600 (32-bit, non-prefetchable) [size=256]
 Capabilities: <access denied>

02:09.4 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev ff) (prog-if ff)
 !!! Unknown header type 7f

SD cards are detected, but Memory Stick cards are not. Bugs have been posted for the lack of support for XD and MMC cards as well.

Eymen A (eal) wrote :

Using 2.6.24-19-generic,
I can confirm Memory Stick cards are not detected at all.

Matthew Woerly (nattgew) wrote :

Thanks for confirming... I know the newest kernel at least (2.6.25.7) has an option for Ricoh readers. Does that fix this? I haven't had the chance to check...

Changed in linux:
status: New → Confirmed

Does SD cards work in your reader?
i have the rev22 too and i tried to compile the ricoh_mmc modules from 2.6.25.9 and add them to my 2.6.24-19 (ubuntu) kernel but now i have kernel freezes when i put in a SD card.

greetz, Andi

Matthew Woerly (nattgew) wrote :

Yes, SD cards work by default for me with the Ubuntu kernel. Memory Sticks do not. Does recompiling ricoh_mmc do anything for Memory Sticks?

For me, the Cardreader completely doesn't work. i don't know why... you can try it, but save your original .ko files.

greetz.

Armands (armandjohn) wrote :

Also using 2.6.24-19-generic (Hardy), on my Asus F3JP, Memory Stick Pro card is not detected. lspci info:
06:01.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller
06:01.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 19)
06:01.2 System peripheral: Ricoh Co Ltd R5C843 MMC Host Controller (rev 01)
06:01.3 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 0a)

Sybrand (sybrand-strauss) wrote :

The built in sony memory stick reader does not work for me on Hardy (2.6.24-19-generic)
SD does work.
I have a HP dv2716ca.
lspci says:
08:09.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller (rev 05)
08:09.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22)
08:09.2 System peripheral: Ricoh Co Ltd R5C843 MMC Host Controller (rev 12)
08:09.3 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)
08:09.4 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev ff)

The Ubuntu Kernel Team is planning to move to the 2.6.27 kernel for the upcoming Intrepid Ibex 8.10 release. As a result, the kernel team would appreciate it if you could please test this newer 2.6.27 Ubuntu kernel. There are one of two ways you should be able to test:

1) If you are comfortable installing packages on your own, the linux-image-2.6.27-* package is currently available for you to install and test.

--or--

2) The upcoming Alpha5 for Intrepid Ibex 8.10 will contain this newer 2.6.27 Ubuntu kernel. Alpha5 is set to be released Thursday Sept 4. Please watch http://www.ubuntu.com/testing for Alpha5 to be announced. You should then be able to test via a LiveCD.

Please let us know immediately if this newer 2.6.27 kernel resolves the bug reported here or if the issue remains. More importantly, please open a new bug report for each new bug/regression introduced by the 2.6.27 kernel and tag the bug report with 'linux-2.6.27'. Also, please specifically note if the issue does or does not appear in the 2.6.26 kernel. Thanks again, we really appreicate your help and feedback.

Sybrand (sybrand-strauss) wrote :

I compiled with 2.6.27-rc5 and tried - the bug remains.

Matthew Woerly (nattgew) wrote :

With the 2.6.27-7 Intrepid kernel, this problem remains.

Noel J. Bergman (noeljb) wrote :

Remove this from being a duplicate of Bug 202490. Although both are related to missing drivers for the RICOH media reader, that is for an xD driver, this is for a MemoryStick driver, and they are not the same.

Noel J. Bergman (noeljb) wrote :

Would someone with sufficient rights please mark this as a Wishlist litem?

Noel J. Bergman (noeljb) on 2009-01-01
description: updated

With the 2.6.27-9 Intrepid kernel, only the SD works. Memory Stick doesn't.

Same problem on Sony Vaio FW series. Model FW21E.

Memory Stick dosen´t work

Ali Shtarbanov (ametedinov) wrote :

I have the same problem on hp Pavilion dv 6200. Memory sticks don't work. I am using the latest version of Ubuntu and the latest kernel. I also tried OpenSUSE 11.1 x64 (the latest), and many other distributions but still no success. I opened a bug too and it was marked as duplitace <a href=https://bugs.launchpad.net/ubuntu/+source/linux/+bug/314903>bug 314903</a>

Ali Shtarbanov (ametedinov) wrote :

... thought html tags work. Here is the link again https://bugs.launchpad.net/ubuntu/+source/linux/+bug/314903

Noel J. Bergman (noeljb) wrote :

> Memory sticks don't work.

Right. We know. There is simply no driver at all for the device. Perhaps someday there will be one.

spiepie (spiepie) wrote :

hi same problem with Sony Vaio VGN FS215E

removed windows so cant use memory stick slot any more should have stayed with MS?

dissapointed
si

Matthew Woerly (nattgew) wrote :

If it's very important that the built-in reader work, then, yes, you should have stayed with MS.
MemoryStick readers are pretty cheap and simple, if you need to read a MemoryStick, then you should go with that.

Motin (motin) wrote :

How hard is it to get hacking on a driver for this chipset?

As was the case for the Texas Instruments devices: "TI refused to publish a complete datasheet for any of the FlashMedia devices rendering them useless anywhere except M$ Windows"

Still, the tifmxx driver was and is being developed.

So, can this possibly be done for the Ricoh chipset? Maybe it's even possible to re-use code from the tifmxx driver (MS specifications, code structure etc)?

Project page TI driver:
http://developer.berlios.de/projects/tifmxx

Maybe someone can create a new project in launchpad for this driver, set up the basic driver files etc and at least get a dummy driver up that detects that a MS or xD card has been inserted into the bay - so that we at least can inform the uninformed user that "Sorry, but there are currently no available drivers for MemoryStick or xD cards for your built-in card reader"

What about that?

Karunadheera (karunadheera) wrote :

<quote>
Maybe someone can create a new project in launchpad for this driver, set up the basic driver files etc and at least get a dummy driver up that detects that a MS or xD card has been inserted into the bay - so that we at least can inform the uninformed user that "Sorry, but there are currently no available drivers for MemoryStick or xD cards for your built-in card reader"
</quote>

That is a good idea. In my Asus F3E also, memory stick duo card does not work.

Bais (bais) wrote :

Same problem here with HP Compaq 8710w
ubuntu jaunthy 9.04

[ 13.266225] sdhci: Secure Digital Host Controller Interface driver
[ 13.266227] sdhci: Copyright(c) Pierre Ossman
[ 13.304264] input: PC Speaker as /devices/platform/pcspkr/input/input6
[ 13.401776] ricoh-mmc: Ricoh MMC Controller disabling driver
[ 13.401778] ricoh-mmc: Copyright(c) Philip Langdale
[ 13.401812] ricoh-mmc: Ricoh MMC controller found at 0000:02:06.4 [1180:0843] (rev 10)
[ 13.401830] ricoh-mmc: Controller is now disabled.

[...]

[ 2939.235883] ricoh-mmc: Controller is now re-enabled.
[ 2945.693157] ricoh-mmc: Ricoh MMC Controller disabling driver
[ 2945.693163] ricoh-mmc: Copyright(c) Philip Langdale
[ 2945.693227] ricoh-mmc: Ricoh MMC controller found at 0000:02:06.4 [1180:0843] (rev 10)
[ 2945.693269] ricoh-mmc: Controller is now disabled.

My kernel version is:
Linux baix 2.6.28-11-server #40-Ubuntu SMP Fri Apr 3 18:30:08 UTC 2009 x86_64 GNU/Linux

I have a digital camera with xD-card...

let me updated plz.

by BAIS

Karunadheera (karunadheera) wrote :

I have an Asus F3E. It also has the following in dmesg.
[ 13.155991] ricoh-mmc: Ricoh MMC Controller disabling driver
[ 13.155994] ricoh-mmc: Copyright(c) Philip Langdale
[ 13.156039] ricoh-mmc: Ricoh MMC controller found at 0000:08:01.2 [1180:0843] (rev 12)
[ 13.156059] ricoh-mmc: Controller is now disabled.

And in the "lspci -v" i get the following error. what does that mean?

08:01.4 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev ff) (prog-if ff)
 !!! Unknown header type 7f

 I have attached the complete dmesg, lcpci -v and lsusb -v.

Karunadheera (karunadheera) wrote :

And for the previous comment i forgot to add the kernel information.

prageeth@prageeth-laptop:~$ uname -a
Linux prageeth-laptop 2.6.28-11-generic #39-Ubuntu SMP Thu Apr 2 03:00:35 UTC 2009 i686 GNU/Linux

prageeth@prageeth-laptop:~$ cat /etc/lsb-release
DISTRIB_ID=Ubuntu
DISTRIB_RELEASE=9.04
DISTRIB_CODENAME=jaunty
DISTRIB_DESCRIPTION="Ubuntu jaunty (development branch)"

nubuser (wififu) wrote :

Not work in jaunty :(

root@Oo:~# lspci | grep -i rico
03:01.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller
03:01.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 19)
03:01.2 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 0a)
03:01.3 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev 05)

root@Oo:~# cat /etc/lsb-release
DISTRIB_ID=Ubuntu
DISTRIB_RELEASE=9.04
DISTRIB_CODENAME=jaunty
DISTRIB_DESCRIPTION="Ubuntu 9.04"
root@Oo:~#

with a card:

root@Oo:~# fdisk -l

Disque /dev/sda: 98.5 Go, 98522403840 octets
255 têtes, 63 secteurs/piste, 11978 cylindres
Unités = cylindres de 16065 * 512 = 8225280 octets
Identifiant de disque : 0x0f800000

Périphérique Amorce Début Fin Blocs Id Système
/dev/sda1 * 1 5705 45825381 7 HPFS/NTFS
/dev/sda2 5706 11604 47383717+ 83 Linux
/dev/sda3 11605 11978 3004155 82 Linux swap / Solaris

I don't have my card in list...

macrowiz49 (macrowiz49) wrote :

I'm just curious... is there any way to work around this issue? Are there wrappers that you could use on the windows drivers like we do with wireless (ndiswrapper)? Is there a way to access it using windows as a guest OS in VirtualBox?

I have not found any working ways to resolve this issue short of dual booting. In a host/client virtualization, the client only has virtualized access to the hardware that is installed by the host OS and identified by the virtualization program.

Regards,
Kyle

> Date: Sun, 26 Apr 2009 19:41:53 +0000
> From: <email address hidden>
> To: <email address hidden>
> Subject: [Bug 238208] Re: Need MemoryStick driver Ricoh R5C822 chipset
>
> I'm just curious... is there any way to work around this issue? Are
> there wrappers that you could use on the windows drivers like we do with
> wireless (ndiswrapper)? Is there a way to access it using windows as a
> guest OS in VirtualBox?
>
> --
> Need MemoryStick driver Ricoh R5C822 chipset
> https://bugs.launchpad.net/bugs/238208
> You received this bug notification because you are a direct subscriber
> of the bug.

_________________________________________________________________
Windows Live™ SkyDrive™: Get 25 GB of free online storage.
http://windowslive.com/online/skydrive?ocid=TXT_TAGLM_WL_skydrive_042009

Confirmed a problem with memory stick using Jaunty 64-bit.

$ lspci | grep -i rico
03:01.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller
03:01.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 19)
03:01.2 System peripheral: Ricoh Co Ltd R5C843 MMC Host Controller (rev 0a)
03:01.3 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 05)
03:01.4 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev ff)

$ cat /etc/lsb-release
DISTRIB_ID=Ubuntu
DISTRIB_RELEASE=9.04
DISTRIB_CODENAME=jaunty
DISTRIB_DESCRIPTION="Ubuntu 9.04"

$ uname -a
Linux dell 2.6.28-11-generic #42-Ubuntu SMP Fri Apr 17 01:58:03 UTC 2009 x86_64 GNU/Linux

SD cards work flawlessly out of the box. No extra drivers needed. I believe the duties are handled by mmc_block kernel module driver. Maybe also ricoh_mmc module, not sure.

I haven't tried MMC cards but they supposedly work using the following workaround: http://ubuntuforums.org/showthread.php?t=731892

The same trick doesn't work for MS cards as suggested by the aforementioned thread.

Ichik (fch-ar) wrote :

This is affecting me too (fdisk doesn't show me my memory stick but works fine with my sd card)...

lion1131 (lion1131) wrote :

This is affecting me too

aguzmanc (alejo-g-c) wrote :

My Memory Stick has the same problem:

07:09.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller (rev 05)
07:09.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22)
07:09.2 System peripheral: Ricoh Co Ltd R5C843 MMC Host Controller (rev 12)
07:09.3 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)
07:09.4 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev ff)

Please keep us updated about any workarround...

Nicolas (nicolas-espina) wrote :

Same here:

01:09.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller (rev 05)
01:09.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22)
01:09.2 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)
01:09.3 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev 12)

paolo (morhelm) wrote :

Same problem:

01:09.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller (rev 05)
01:09.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22)
01:09.2 System peripheral: Ricoh Co Ltd R5C843 MMC Host Controller (rev 12)
01:09.3 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)
01:09.4 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev ff)

Luke Faraone (lfaraone) wrote :

Unduplicate, XD != MMC

Changed in linux (Ubuntu):
importance: Undecided → Wishlist
Changed in dell:
status: New → Confirmed
Reloweb (reloweb) wrote :

Same request for Dell Studio 1557 notebook...

Tony Espy (awe) on 2010-01-22
Changed in dell:
importance: Undecided → Wishlist
Tony Espy (awe) wrote :

Marking as WontFix in the Dell project.

Changed in dell:
status: Confirmed → Won't Fix
VuDu (vudu-curse) wrote :
Maxim Levitsky (maximlevitsky) wrote :

@VuDu, this is nice news

However, you don't need any hope for that driver.
I know exactly how to write it, and it is only matter of time before I do.
I already managed to read whole card.

Maxim Levitsky (maximlevitsky) wrote :

@YannUbuntu, not this isn't linked.
We talk here about Sony Memory Stick cards, not MMC cards.

Changed in dell:
assignee: nobody → Maxim Levitsky (maximlevitsky)
assignee: Maxim Levitsky (maximlevitsky) → nobody
Changed in linux (Ubuntu):
assignee: nobody → Maxim Levitsky (maximlevitsky)
VuDu (vudu-curse) wrote :

@Maxim Levitsky: now that's great news! ;)

Mahesh Asolkar (asolkar) wrote :

@Maxim Levitsky: Awesome! Do count on us for alpha/beta testing.

Maarten Kossen (mpkossen) wrote :

May I ask if there in an update on this?

This problem also affects me. I'll definitely help testing!

Geek87 (geek87) wrote :

+1

Maxim Levitsky (maximlevitsky) wrote :

I have exams now, in about 2 months, I plan to write the driver.

Vladimir Hidalgo (vlad88sv) wrote :

Great to hear some hopes on this!, even through some users had to wait almost 2 years for this support, their patience will be rewarded!.

I'm on Linux 2.6.34-020634-generic and only SD works.

AlexW (alex.wedensky) wrote :

tested out the 2.6.35-rc1-lucid kernel from PPA with Maxim's fixes re: Ricoh SD controller -- SD cards work, MS Pro Duo -- no go.

Vladimir Hidalgo (vlad88sv) wrote :

Where did you found such fixes?, I think Maxim has not done them as yet!

VuDu (vudu-curse) wrote :

I'm curious too. Did Maxim produced any patches already?

Maxim Levitsky (maximlevitsky) wrote :

I didn't yet.
I did wrote driver to read xD cards with this controller though. It is in 2.6.35.

As soon as I finish exams, I get to it.

AlexW (alex.wedensky) wrote :

good luck with your exams, Max!

Maxim Levitsky (maximlevitsky) wrote :

To those that didn't believe that I would write the driver...

Everything works more or less OK here.
Note that this driver is very experimental, thus don't use with valuable data.

Thanks for Alex Dubov for writing the memorystick subsystem, and personal help for understanding how MemorySticks work.
This did shorten my work by very large percent.

Missing features:
high level support MemoryStick Standard support (<128M), because Alex didn't finish debugging it, and now too busy doing so
These cards are also quite raw, thus one have to be careful not to wear sectors (they don't have wear leveling).
I hope I will add that support too. Can't say exactly when.

My driver does transport commands for these devices, there is just need for high-level driver.
(I actually did full dump of my 64MB memory stick standard duo)

Compilation is simple: make && sudo make install.

Then to load (on next boot it will load automaticly)
sudo make load

Tested on 2.6.35, but _should_ work on 2.6.34 and maybe even below.
Package contains both my driver and whole memstick subsystem.
I also add small udev rule to display correct icon for the device.

Note that its normal that card won't be automounted on insert, this is due to stupidity of devicekit.

Please look at 'Places' before deciding that driver doesn't work.

thank you for this! will test when i have my lapitopy repaired. ^_^

Stunts (f-pinamartins) wrote :

Thank you for this driver!

However, I get the following after making sudo make load:

modprobe -r r592
FATAL: Module r592 not found.
make: *** [load] Error 1

What's missing here?

Maxim Levitsky (maximlevitsky) wrote :

do:

sudo depmod -a
sudo modprobe r592

Stunts (f-pinamartins) wrote :

sudo depmod -a

gives no output.

sudo modprobe r592

results in:
FATAL: Module r592 not found.

So I guess it's still a no go for me..

Maxim Levitsky (maximlevitsky) wrote :

@Stuns, you are doing something wrong.

Can you join IRC now, I help you,
I am on freenode. My nick MaximLevitsky

Maxim Levitsky (maximlevitsky) wrote :

Slightly modified version, should install better now

León Álvarez (locoxella) wrote :

Maxim, just wanted to tell: you are the man.

Its been several days, weeks, or whatever since im following your advance with this driver. You are awesome. Thanks for all the work you've done so far.

Stunts (f-pinamartins) wrote :

Just one extra comment:

This will not work on Lucid. Since the kernel 2.6.34, some block layer functions have been renamed. Therefore, under 2.6.32, this will not compile.

It is, however, in theory, possible to hack the source code to rename the mentioned functions. One example error is here:

... r592/core/mspro_block.c:1231: error: implicit declaration of function ‘blk_queue_max_segments’

And here is where I found out what the problem was:

http://old.nabble.com/Kernel-2.6.34-td28609864.html

Anyway, once again, excellent job!

Hallo Maxim,
really thanks for your work !

David

Under 2.6.32, this will not compile.
mspro_block.c:1231: error: implicit declaration of function ‘blk_queue_max_segments’

Maxim Levitsky (maximlevitsky) wrote :

@Stunts, and as soon as I finish debugging one minor bug I found in the driver (after suspend/resume, card is removed then inserted due to IO error), I port it there.

In fact you can just compile _only_ r592.c against 2.6.32 memstick core, and it probably will work.
I update that soon.

Maxim Levitsky (maximlevitsky) wrote :

Slightly updated version.
Fixed the above bug, made it compile on 2.6.32 (trivial problem)
Minor refactoring & correctness fixes

Maxim Levitsky (maximlevitsky) wrote :

oops, I still think I develop r852... anyway, this is just tarball name typo. Driver is r592

description: updated
Gabrielcik (miliy-multik) wrote :

I tried to do "make" but i get this error:

make -C /lib/modules/2.6.32-24-generic/build M=/home/gabrielcik/stick
make[1]: Entering directory `/usr/src/linux-headers-2.6.32-24-generic'
  CC [M] /home/gabrielcik/stick/host/r592.o
/home/gabrielcik/stick/host/r592.c: In function ‘r592_probe’:
/home/gabrielcik/stick/host/r592.c:768: error: incompatible type for argument 1 of ‘dma_alloc_from_coherent’
include/asm-generic/dma-coherent.h:9: note: expected ‘struct device *’ but argument is of type ‘struct device’
/home/gabrielcik/stick/host/r592.c:768: warning: passing argument 4 of ‘dma_alloc_from_coherent’ from incompatible pointer type
include/asm-generic/dma-coherent.h:9: note: expected ‘void **’ but argument is of type ‘int *’
make[3]: *** [/home/gabrielcik/stick/host/r592.o] Error 1
make[2]: *** [/home/gabrielcik/stick/host] Error 2
make[1]: *** [_module_/home/gabrielcik/stick] Error 2
make[1]: Leaving directory `/usr/src/linux-headers-2.6.32-24-generic'
make: *** [build] Error 2

What to do?

I use Ubuntu 10.04 on a Vaio W. Thank you!

Maxim Levitsky (maximlevitsky) wrote :

Sorry about that, updated driver below

description: updated
Gabrielcik (miliy-multik) wrote :

I tried "r592-v2" and i was able to make and sudo make install wihtout any issue on Ubuntu lucid with the last Kerner.

After a reboot, I tried to mount a Memory stick pro duo 2GB and it really works, i was able to read and write on it!

Great work! Thank you.

P.s.
I tried it only once, if after i will discover some bug, i will let u know.

tags: added: patch
Ali Shtarbanov (ametedinov) wrote :

Will this be implemented in the next version of Ubuntu? I mean will it be available in the ISO?

Vladimir Hidalgo (vlad88sv) wrote :

Maxim, thank you for your work on this driver.

Is there any GIT for it?, it will be much easier to stay up to date with your fixes this way!.

Thanks again.

Vladimir Hidalgo (vlad88sv) wrote :

BTW, make & make install did succed, but after rebooting it still does not work :(

I'm inserting the 2GB memory stick pro duo (brand: SanDisk) in the Magic Gate port but even the led does not blink.

Vladimir Hidalgo (vlad88sv) wrote :

lspci -v

03:00.0 SD Host controller: Ricoh Co Ltd Device e822
 Subsystem: Sony Corporation Device 9071
 Flags: bus master, fast devsel, latency 0, IRQ 17
 Memory at f3802000 (32-bit, non-prefetchable) [size=256]
 Capabilities: <access denied>
 Kernel driver in use: sdhci-pci
 Kernel modules: sdhci-pci

03:00.1 System peripheral: Ricoh Co Ltd Device e230
 Subsystem: Sony Corporation Device 9071
 Flags: bus master, fast devsel, latency 0, IRQ 4
 Memory at f3801000 (32-bit, non-prefetchable) [size=256]
 Capabilities: <access denied>

03:00.4 SD Host controller: Ricoh Co Ltd Device e822
 Subsystem: Sony Corporation Device 9071
 Flags: bus master, fast devsel, latency 0, IRQ 19
 Memory at f3800000 (32-bit, non-prefetchable) [size=256]
 Capabilities: <access denied>
 Kernel driver in use: sdhci-pci
 Kernel modules: sdhci-pci

I guess 03:00.0 and 03:00.4 are for SD and 03:00.1 is the magic gate, but it does not seem to be picked up by your driver.

Maxim Levitsky (maximlevitsky) wrote :

Because that is different device.
I don't know how different that device it, but my driver currently only attaches to R5C852 devices

Maxim Levitsky (maximlevitsky) wrote :

It also looks like Ricoh wrote brand new driver for this device, so it might be very different.

Maxim Levitsky (maximlevitsky) wrote :

@Vladimir Hidalgo

You could still try to use my driver. If and only if the device you have is very similar (there is small possibility about that.), my driver might work.

 you can try to change the source in this way:

In r592.c, find this structure:

static const struct pci_device_id r592_pci_id_tbl[] = {

 { PCI_VDEVICE(RICOH, 0x0592), },
 { },
};

And change it to:

static const struct pci_device_id r592_pci_id_tbl[] = {

 { PCI_VDEVICE(RICOH, 0x0592), },
        { PCI_VDEVICE(RICOH, 0xe230), },
 { },
};

Alex Lee (aintaer) wrote :

Tested on Ubuntu Lucid with 2.6.32-24 generic kernel (with a 1GB MS Pro Duo). Confirmed working like a charm. Thanks for the good work, Maxim!

Vladimir Hidalgo (vlad88sv) wrote :

Thank you for your time Maxim.

Well, I guess I'm out of luck, made the change, rebooted and now your driver is picked, but nothing else happen when I insert the card.

$ dmesg | grep -i r592
[ 9.828380] r592 0000:03:00.1: PCI INT B -> GSI 18 (level, low) -> IRQ 18
[ 9.828419] r592 0000:03:00.1: setting latency timer to 64
[ 9.828659] r592: driver succesfully loaded

$sudo lspci -v
03:00.1 System peripheral: Ricoh Co Ltd Device e230
 Subsystem: Sony Corporation Device 9071
 Flags: bus master, fast devsel, latency 0, IRQ 18
 Memory at f3801000 (32-bit, non-prefetchable) [size=256]
 Capabilities: [50] Message Signalled Interrupts: Mask- 64bit+ Queue=0/0 Enable-
 Capabilities: [78] Power Management version 3
 Capabilities: [80] Express Endpoint, MSI 00
 Capabilities: [100] Advanced Error Reporting <?>
 Kernel driver in use: r592
 Kernel modules: r592

Gabrielcik (miliy-multik) wrote :

After 1 day of testing it I got this situation:

it works without any problem with a Sandisk memory stick pro duo of 2GB and it doesn't work with the same memory stick but this time of 4GB.

When i plug in the one of 4GB the light start to blink for few secs and nothing more. After this the drive stop to work and wont mount even the one of 2GB which was working before.

If i restart the pc or deactivate and reactivate the drivers, the device starts to work again but only with the card of 2GB.

Note: After that i remove the 4GB card and i try to deactivate the drivers or restart ubuntu everything freeze for several seconds.

Hope for a fix:)

Maxim Levitsky (maximlevitsky) wrote :

@Gabrielcik, the card isn't by a chance a MemoryStick PRO HG?

Could you contact me via IRC so I will try some debugging on your system?
(I am MaximLevitsky on freenode)

Gabrielcik (miliy-multik) wrote :

I use a Sandisk Memory stick PRO Duo 4GB (Magic gate) identical to my previous one of 2GB.

I attach part of the debug.log, i hope it can be useful.
(u can find what happen when i use a 2GB card and then what happen when i use the other one of 4GB)

About IRC i have never used it, so if it is still needed i will try to understand in what way to contact u.

Thank you.

P.s.

I tried it again and the same result, it seems to work with the one of 4G but under Places doesn't appear anything and then the pc became unstable and freeze if i want to restart it.

Gabrielcik (miliy-multik) wrote :

It is me again...

I was able to make it works...

I made this test: Mount the card with my usb adaptor, copy everything on the hd and format the memory stick.

While i was coping the content, i noticed the presence of a couple of video files (i use the card as memory of a video camera) which were broken and not possible to be copied on the hd.

So i finally formatted the card and mounted without the usb adaptor. It worked! Next step was to copy everything back and un- mount and re-mount it... Still working :)

The problem was probably then in somehow connected with those broken files. (with the USB adapter was working even with these files)

Thank you!

Maxim Levitsky (maximlevitsky) wrote :

This doesn't justify the behavior of memstick subsystem and/or devicekit.

But anyway, it is very likely not a bug in the driver but rather in memorystick subsystem.

Jan Skala (101speirs) wrote :

Hello,

I have found this by accident. I'm waiting for this for a long time, but it still doesn't finish my waiting. I own two old Memory Sticks - 16 and 128MB. Yes you have written something about core and 128MB cards, actually I don't understood that. I use standard Ubuntu 10.04 with its' latest kernel.

When I insert 16MB MS it blinks twice.

dmesg outputs:

[ 3158.043280] r592: IRQ: card added
[ 3158.043566] r592: IRQ: card added
[ 3158.540166] r592: IRQ: card removed
[ 3158.540180] memstick_host memstick0: memstick_check started
[ 3158.650199] memstick memstick0: if_mode = 00
[ 3158.650210] memstick_host memstick0: new card 00, 00, 00
[ 3158.650288] memstick_host memstick0: memstick_check finished
[ 3159.041381] memstick_host memstick0: memstick_check started
[ 3159.041441] memstick memstick0: if_mode = 00
[ 3159.041450] memstick_host memstick0: new card 00, 00, 00
[ 3159.041589] memstick_host memstick0: memstick_check finished

when I put 128MB card in it blinks only once and dmesg outputs:

[ 3295.661306] r592: IRQ: card removed
[ 3296.160127] memstick_host memstick0: memstick_check started
[ 3296.160314] memstick_host memstick0: memstick_check finished
[ 3339.363790] r592: IRQ: card added
[ 3339.363858] r592: IRQ: card added
[ 3339.860089] memstick_host memstick0: memstick_check started
[ 3339.970211] memstick memstick0: if_mode = 00
[ 3339.970249] memstick_host memstick0: new card 00, 00, 00
[ 3339.970332] memstick_host memstick0: memstick_check finished

Newertheless nothing works, but I look forward it will once and I thank you for your effort. I would like to help you with anything. (Now I'm waiting for another MS 1GB so I can add some other feedback.)

Vladimir Hidalgo (vlad88sv) wrote :

Maxim Levitsky, do you have any plans on supporting Ricoh Co Ltd Device e230?, or I should lose any hope on this?

Maxim Levitsky (maximlevitsky) wrote :

Jan Skala, both your memstick aren't PRO, and thus not supported yet.
I am writing the support right now.

On Mon, 2010-08-09 at 18:52 +0000, Vladimir Hidalgo wrote:
> Maxim Levitsky, do you have any plans on supporting Ricoh Co Ltd Device
> e230?, or I should lose any hope on this?
>

It is very unlikely that I do the driver for that device, because I
suspect that this is very different device.
Maybe I buy a laptop with this device sometime in future.

Maxim, I understand.

There's any possibility that if I provide you with any data you need about this device, can you determine if it's possible to make this driver wherever is possible?

I could even let a memory card inserted and full 24/7 SSH access to you if needed!

If I were wealthy, I would send you a free laptop for developing, sadly, that's not the case LOL.

Anyway, thank you for your time and dedication to make Linux even better.

Maxim Levitsky (maximlevitsky) wrote :

@Jan Skala and evereone else.

Here is new version.
All last week I was busy writing support for old memory stick cards.
Now it work quite well.
Note that such card are bare (that is no wear leveling, bad block hiding), and thus all the hard work is done by my driver.

Therefore it can in theory damage the card by overwriting the same sector over and over.
However, I put it a lot f safety checks and thus if anything goes wrong I turn off write access completely.
I tested it for few days on my 64MB card, and it does work very well.

Jan Skala (101speirs) wrote :

Hi, thank you for your work. Yesterday, new MS Pro Duo 1GB arrived and it works fine. Now I'm testing those two old MS 16 and 128MB and they are working as well. The time of stupid cable connection ends.

VuDu (vudu-curse) wrote :

Hi Maxim,

I'm using a M2, on a Pro Duo adapter and both on a Duo adapter. :)

lspci -v

08:01.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22)
 Subsystem: ASUSTeK Computer Inc. Device 1877
 Flags: bus master, medium devsel, latency 64, IRQ 17
 Memory at febff400 (32-bit, non-prefetchable) [size=256]
 Capabilities: <access denied>
 Kernel driver in use: sdhci-pci
 Kernel modules: sdhci-pci

08:01.2 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)
 Subsystem: ASUSTeK Computer Inc. Device 1877
 Flags: bus master, medium devsel, latency 64, IRQ 17
 Memory at febfec00 (32-bit, non-prefetchable) [size=256]
 Capabilities: <access denied>
 Kernel driver in use: r592
 Kernel modules: r592

08:01.3 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev 12)
 Subsystem: ASUSTeK Computer Inc. Device 1877
 Flags: bus master, medium devsel, latency 64, IRQ 3
 Memory at febfe800 (32-bit, non-prefetchable) [size=256]
 Capabilities: <access denied>

dmesg
...
r592 0000:08:01.2: PCI INT B -> GSI 17 (level, low) -> IRQ 17
r592: driver succesfully loaded
memstick_host memstick0: memstick_check started
memstick_host memstick0: memstick_check finished
[***card inserted***]
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card added
r592: IRQ: card removed
memstick_host memstick0: memstick_check started
r592: IRQ: card removed
memstick_host memstick0: memstick_check finished
memstick_host memstick0: memstick_check started
memstick_host memstick0: memstick_check finished

Doesn't seem to be working, might it be because it's a R5C592?

Btw, are you hosting your project on svn, git or something?

Thanks for your work. ;)

Maxim Levitsky (maximlevitsky) wrote :

@VuDu

Please load the driver with debug=2

sudo modprobe -r r592
sudo modprobe r592

Insert the card and post the kernel log.

It might be that your card is PRO HG inside and might not be supported by hardware.
Or this might be contact issue.

summary: - Need MemoryStick driver Ricoh R5C822 chipset
+ Need MemoryStick driver Ricoh R5C592 (part of R5C832/822)chipset
summary: - Need MemoryStick driver Ricoh R5C592 (part of R5C832/822)chipset
+ Need MemoryStick driver Ricoh R5C592 (part of R5C832/822chipset)
Jan Skala (101speirs) wrote :

VuDu, I have also "Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter". You just have to open "Computer" or "Places" where the card will appear.

  • quiet.patch Edit (2.4 KiB, text/x-patch; name="quiet.patch"; charset="UTF-8")

I have a 16GB M2 card I tried this with, and it worked fine, but it
filled up the dmesg logs needlessly. So, I turned off DEBUG, and it
stopped working! Evidently, it was relying on the delay resulting from
successive printk() executions. I decided to leave in DEBUG and make
verbosity optional, but at least one delay had to be added for it to
work again. Attached is a patch to your most recent tarball. Thank you!

VuDu (vudu-curse) wrote :

@Maxim: tryed it again, now in debug and it worked. :) Mounted and it read the M2 contents :)
The tried with a Lexar 4G MS Duo Pro but it wouldn't mount.

here's the dmesg tail:
r592: IO: done IO, sleeping
mspro_block memstick0: blk_fetch
mspro_block memstick0: trying again
mspro_block memstick0: data transfer: cmd 20, lba be, count 1
r592: IO thread woken to process requests
r592: IO: executing MS_TPC_WRITE_REG LEN=8
r592: IO: executing MS_TPC_SET_CMD LEN=1
r592: IO: executing MS_TPC_READ_LONG_DATA LEN=512
r592: doing dma transfer
r592: IRQ: dma done
mspro_block memstick0: complete 1, 0
mspro_block memstick0: transferred 200 (0)
mspro_block memstick0: blk_fetch
mspro_block memstick0: issue end
r592: IO: done IO, sleeping
FAT: bogus number of reserved sectors
VFS: Can't find a valid FAT filesystem on dev mspblk0p1.

It's from a PSP and the PSP can read and write to it. Using the USB card readers works fine. Hope it helps.

VuDu (vudu-curse) wrote :

Btw, I know this is a ubuntu bug tracker, but I'm using ArchLinux now. I was using ubuntu the first time I commented. ;)

Maxim Levitsky (maximlevitsky) wrote :

@VuDu.

What you are seeing with Lexar card, might be the ugliest problem that nobody would accept a fix for.

I have seen this as well.
It seems that card readers look at partition table and 'corrects' it on the fly, but my driver just passes what is written.

What I need is two dumps of first say 1MB of the card, using my driver and usb card reader.

Do something like that:

For my driver (please _don't_ use mspblk0p1!)
dd if=/dev/mspblk0 of=file_r852 bs=1K count=1024

And for card reader, figure out which of sdb/sdc/.. etc is the reader, and do

If card reader is sdb, then:

dd if=/dev/sdb of=file_usb bs=1K count=1024

If you have any sensitive data on the card, it might be included in dump. Don't post then!

Maxim Levitsky (maximlevitsky) wrote :

@Daniel Gimpelevich, the delay you have to add really worries me.
There is something very ugly going on....
Can you contact me via IRC (I am MaximLevitsky on freenode), so we could debug that together?

@VuDu, I would be interesting in some debugging too

Stas Solovey (whats-up) wrote :

Driver not working with MemStick Duo Adapter

@stmc, what card?

VuDu (vudu-curse) wrote :

@Maxim: After a second try it's working with the Lexar too. That's weird.

Stas Solovey (whats-up) wrote :
Stas Solovey (whats-up) wrote :

MS Duo 1gb works fine

@VuDu with lot of help from Daniel Gimpelevich we figured out the cause of this problem.

I post updated patches soon.

@Vudo, you have 4GB of memory or more on the system, right?

@stmc

First load my card with

sudo modprobe -r r592
sudo modprobe -r r592 debug=2

Then insert one of non-working cards, and post the kernel log.

Updated version

description: updated
VuDu (vudu-curse) wrote :

@Maxim, yes, running arch x64 with 4GB of RAM. What was the problem? ;)

VuDu (vudu-curse) wrote :

@Maxim, is that last memstick-v2.tar.bz2 (34.3 KiB, application/x-tar) more recent then the previous memstick-v3.tar.bz2 (30.3 KiB, application/x-tar)?
Are you using some VCS on your work?
I was thinking about creating a package for archlinux and it would be easier to get the last version of your work from svn/bzr/git than a link from here that gets "broken" with every update.

@VuDu.

Yep, sorry about version number confusion.

I use git here, but I create a snapshot.
(Actually I mostly work directly on kernel tree)

The problem was bad dma handling to memory > 4GB
(And yes, you have it, because some of the memory < 4GB is used for IO devices, so to compensate, some of the system memory
is placed at > 4GB address)

@VuDu:

Did you test the latest verision?
In case you didn't understand, latest version is the
https://bugs.launchpad.net/opensuse/+bug/238208/+attachment/1506369/+files/memstick-v2.tar.bz2

@stmc
ping

@stmc: the log looks very good.

Could you contact me via IRC?
I am MaximLevitsky on freenode

Also I am sure that you don't use latest version, because I see
'Unknown symbol __udivdi3'

I fixed this error in latest version.

lion1131 (lion1131) wrote :

Thanks a lot, my 128MB Sony memory stick tested. it worked with a second
mount, the first failed with the following dmesg | tail.
[ 5999.165180] r592: IRQ: card added
[ 5999.169975] r592: IRQ: card added
[ 5999.186805] r592: IRQ: card added
[ 5999.680095] memstick_host memstick0: memstick_check started
[ 5999.792836] memstick memstick0: if_mode = 00
[ 5999.792860] memstick_host memstick0: new card 00, 00, 00
[ 6000.951599] msblk0: p1
[ 6000.955931] memstick_host memstick0: memstick_check finished
[ 6008.271181] FAT: bogus number of reserved sectors
[ 6008.271187] VFS: Can't find a valid FAT filesystem on dev msblk0p1.

Thanks again for the hard work.

Stas Solovey (whats-up) wrote :

@Maxim Levitsky, it is my blame, card was not formatted
now it working fine

@stmc:

Both non-working cards work now, right?
Did you install latest version now?
Do the cards work consistently, that is if you instert/remove them few times, do they always work?

@VuDu:
ping

Stas Solovey (whats-up) wrote :

@Maxim Levitsky,
I reinstall driver from your post #107 "memstick-v2.tar.bz2", I think it is the latest.
All cards always work.

VuDu (vudu-curse) wrote :

@Maxim: tried the last version and it works fine on both cards. But, I can confirm what stmc said: the first time I tried, they failed to mount.

@Vudu, so with latest version, card still fails to mount on first attempt?

Can you try few more times. Can you reproduce this?
Maybe it was just bad contact or something.

VuDu (vudu-curse) wrote :

Now I can't know since it's working and I don't have another untested card.

From the tests I did with my 2 cards (one a M2) it seems that when I first try to mount a card it fails with that filesystem error. After that, it works just fine. Happened with the M2 using the v3 (previous version) and the Lexat MS Duo Pro using the v2 (latest version).

Backported drivers for xD and MS parts (+fixes for MMC part) are now hosted at gitorious.org
Since last release, not much have been changed.

http://gitorious.org/ricoh-kernel

You can download it ether by doing (preffered):
git clone git://gitorious.org/ricoh-kernel/ricoh-kernel.git

Then you can receive updates using
git pull

or you can press on 'Source tree' and download a snapshot by pressing 'Download master as tar.gz'

description: updated
VuDu (vudu-curse) wrote :

gitorious, nice :)

Maxim, do you expect your work to be merged to kernel soon?
I'm probably going to make a package for Archlinux, but if it's closed to be merged to kernel, maybe it's not necessary. ;)

Once again, thanks for your work. =)

Stunts (f-pinamartins) wrote :

@ VuDu:
There is already an Arch Linux package for this:
http://aur.archlinux.org/packages.php?ID=39386
You can use it while this doesn't get merged. =-)

VuDu (vudu-curse) wrote :

Nice! Didn't notice. ;)

Johny (johny9878) wrote :

Please, help me. I have Lenovo notebook with the card reader -

CardBus bridge : Ricoh Co Ltd RL5c476 II (rev ba)
FireWire (IEEE 1394) : Ricoh Co Ltd R5C832 IEEE 1394 Controller (rev 04) (prog-if 10)
SD Host controller : Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 21)
System peripheral : Ricoh Co Ltd R5C843 MMC Host Controller (rev ff) (prog-if ff)
System peripheral : Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 11)
System peripheral : Ricoh Co Ltd xD-Picture Card Controller (rev 11)

SD works well, but I need the MS reader. I tried install (i hope i did it right - i downloaded the tar file, unpacked and in terminal i set it on right folder and i did "sudo make") both packages from Maxim, restarted computer and still it is not mounting.
I am beginner, can you help me, what should I do, please?
Thank you very much

Jan Skala (101speirs) wrote :

Johny, open that directory in terminal again and type "sudo make install", let it work and than "sudo make load" - you don't have to restart computer. BTW "make" doesn't need sudo

Johny (johny9878) wrote :

@ Jan Skala:
I tried it, but the commands don't work -
johny@johny-ntb:~/Plocha/a$ make install
sudo mkdir -p /lib/modules/2.6.32-24-generic-pae/kernel/drivers/memstick/core
sudo mkdir -p /lib/modules/2.6.32-24-generic-pae/kernel/drivers/memstick/host
sudo cp ./core/memstick.ko /lib/modules/2.6.32-24-generic-pae/kernel/drivers/memstick/core/memstick.ko
cp: nelze získat informace o „./core/memstick.ko“: No such file or directory
make: *** [install] Error 1
johny@johny-ntb:~/Plocha/a$ make load
modprobe -r r592
FATAL: Module r592 not found.
make: *** [load] Error 1
johny@johny-ntb:~/Plocha/a$

It looks, the packages are wrong. I tried both of them. What should I do now, please?
Thank you

Johny (johny9878) wrote :

@Daniel Gimpelevich:
What did I wrong, please?

Johny (johny9878) wrote :

I just figured it out. My mistake, thank you for help.

swissz (zsarosi) wrote :

Hi!

I tried to compile it on Ubuntu 9.10 x86_64 (gcc version 4.1.3), but the compiler complains:
---------------------
user@localhost:~/Downloads/ricoh_driver/ricoh-kernel/memstick$ make
make -C /lib/modules/2.6.31-22-generic/build M=/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick
make[1]: Entering directory `/usr/src/linux-headers-2.6.31-22-generic'
/usr/src/linux-headers-2.6.31-22-generic/arch/x86/Makefile:80: stack protector enabled but no compiler support
  CC [M] /home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.o
In file included from /home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:23:
/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.h:177:7: warning: no newline at end of file
/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:858: warning: data definition has no type or storage class
/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:858: warning: type defaults to ‘int’ in declaration of ‘SIMPLE_DEV_PM_OPS’
/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:858: warning: parameter names (without types) in function declaration
/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:869: error: ‘r592_pm_ops’ undeclared here (not in a function)
make[3]: *** [/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.o] Error 1
make[2]: *** [/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host] Error 2
make[1]: *** [_module_/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick] Error 2
make[1]: Leaving directory `/usr/src/linux-headers-2.6.31-22-generic'
make: *** [build] Error 2
---------------------

On Wed, 2010-09-08 at 08:57 +0000, swissz wrote:
> Hi!
>
> I tried to compile it on Ubuntu 9.10 x86_64 (gcc version 4.1.3), but the compiler complains:
> ---------------------
> user@localhost:~/Downloads/ricoh_driver/ricoh-kernel/memstick$ make
> make -C /lib/modules/2.6.31-22-generic/build M=/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick
> make[1]: Entering directory `/usr/src/linux-headers-2.6.31-22-generic'
> /usr/src/linux-headers-2.6.31-22-generic/arch/x86/Makefile:80: stack protector enabled but no compiler support
> CC [M] /home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.o
> In file included from /home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:23:
> /home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.h:177:7: warning: no newline at end of file
> /home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:858: warning: data definition has no type or storage class
> /home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:858: warning: type defaults to ‘int’ in declaration of ‘SIMPLE_DEV_PM_OPS’
> /home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:858: warning: parameter names (without types) in function declaration
> /home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.c:869: error: ‘r592_pm_ops’ undeclared here (not in a function)
> make[3]: *** [/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host/r592.o] Error 1
> make[2]: *** [/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick/host] Error 2
> make[1]: *** [_module_/home/user/Downloads/ricoh_driver/ricoh-kernel/memstick] Error 2
> make[1]: Leaving directory `/usr/src/linux-headers-2.6.31-22-generic'
> make: *** [build] Error 2
> ---------------------

Too old kernel (this supports 2.6.32+)
However I will add a compat code there.
The xD part I think should compile on 2.6.31.

Best regards,
Maxim Levitsky

Sneha (sneha-bharath) wrote :

Hey.. I am a newbie .. like very very new to Ubuntu. So please bear with me. i unzipped your master file, unzipped it, switched to memstick directory and ran the make command.I got the following response

sneha@sneha-laptop:~/mem/ricoh-kernel-ricoh-kernel/memstick$ make
make -C /lib/modules/2.6.28-19-generic/build M=/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick
make[1]: Entering directory `/usr/src/linux-headers-2.6.28-19-generic'
  CC [M] /home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.o
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c: In function ‘mspro_block_issue_req’:
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c:683: error: implicit declaration of function ‘__blk_end_request_cur’
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c:687: error: implicit declaration of function ‘blk_rq_pos’
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c:716: error: implicit declaration of function ‘blk_fetch_request’
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c:716: warning: assignment makes pointer from integer without a cast
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c: In function ‘mspro_block_submit_req’:
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c:836: warning: assignment makes pointer from integer without a cast
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c:837: error: implicit declaration of function ‘__blk_end_request_all’
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c: In function ‘mspro_block_init_disk’:
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c:1239: error: implicit declaration of function ‘blk_queue_max_hw_sectors’
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c:1246: warning: assignment discards qualifiers from pointer target type
/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.c:1254: error: implicit declaration of function ‘blk_queue_logical_block_size’
make[3]: *** [/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core/mspro_block.o] Error 1
make[2]: *** [/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick/core] Error 2
make[1]: *** [_module_/home/sneha/mem/ricoh-kernel-ricoh-kernel/memstick] Error 2
make[1]: Leaving directory `/usr/src/linux-headers-2.6.28-19-generic'
make: *** [build] Error 2

I'm running Ubuntu 9.04 on Sony Vaio

Murali Krishnan (maakri) wrote :

Sony Vaio running Ubuntu 10.04. The media stick and sd card work perfectly once the file was made and installed.

@swissz, I have just pushed an update that should make my driver compile and work on your kernel (2.6.31)

@Sneha, really please update your distro, I really don't feel like backporting it to 2.6.28...

Nishant (nishant-singh28) wrote :

First of all....tonnes of thanks for this driver.....you guys saved me loads of cable troubles.
One more thing....just a thought, but it will be easier for people like me if you could write the three step instructions clearly in one place. I had to read through the thing to find them. You know all of us aren't uber geeks ( no offence ).
And yeah, the details:
Card Reader Ricoh 822 on Ubuntu Maverick RC x86_64, Kernel 2.6.35-22, Dell Studio 1555 both read write working normally. Card is detected, doesn't automount on insert. Read write successful.

gldickens3 (gordon-dickens) wrote :

I am running 64 bit Ubuntu 10.10 on a Dell PRecision M6300 with the following SD card reader device:

03:01.2 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)
03:01.3 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev 12)

I am running the following stock Ubuntu 10.10 kernel:

Linux rhino 2.6.35-22-generic #35-Ubuntu SMP Sat Oct 16 20:45:36 UTC 2010 x86_64 GNU/Linux

I found the driver for the Ricoh device here:

http://gitorious.org/ricoh-kernel/ricoh-kernel/trees/master

Brilliant! Many thanks for developing this driver.

After downloading and extracting the tarball I installed the memstick driver with the following commands:

cd memstick
make
make install
make install load

However, my SD card still does not work. What might I be doing wrong? What else do I need to do to get it to work? Do I need to install anything else such as drivers from the mmc, user or xd directory. If so, please provide instructions.

Many thanks in advance of your reply!

Gordon Dickens

King_DuckZ (king-duckz) wrote :

Great work, thanks for your work!
Just to make a little report, this worked great on Debian Squeeze 2.6.32-5, but it doesn't build at all on Mandriva 2.6.33, whining about round_down and other functions not being defined. Adding an include linux/kernel.h or removing the kernel version check around the defines in compatibility.h only causes more errors.

Jior (tepanahui) wrote :

Finally, my Ricoh R5C822 works at all in Ubuntu 10.10, but first i had to do some few things.

1.- open synaptic and mark for install
     linux-headers-2.6.37-5
     linux-headers-2.6.37-5-generic
     linux-image-2.6.37-5-generic

2.- then restart : sudo restart -n

3.- goto software origins and enable backports

4.- then: sudo apt-get update

5.- edit the modules file : sudo gedit /etc/modules and add the sd module tifm_sd to load on start
     and make sure you have it: sudo modprobe tifm_sd
                                                 sudo modprobe tifm_core
                                                 sudo modprobe tifm_7xx1

6.- add some modules for dirs 03:01.x doing sudo modprobe raw1394 and sudo modprobe dv1394

7.-restart again, enter bios, and disable legacy floppy by selecting disable or in some bios just deactivate the boot search in a
floppy drive from the boot secuence (generally with space bar on floppy option in boot secuence, the number on the left side disappears)

8.- just in case sudo modprobe -r floppy

9.-install git doing sudo apt-get git and follow the above instructions

10.- reboot for las time and card reader should work

Important:

Do not try to pull setpci command for kernels 2.6.22 or above
And if you are using virtualbox (ose or branded) 3.2.8 or later you will need to deactivate the floppy support

I really dont know why the cause of this problem, but just for you to know, the ricoh card reader always works for me since 8.04 until 10.04, it just now in 10.10 i have the problem, but reading some forums it seems to be an old item since jaunty.

I probe SD and MMC, i dont use MS, so i dont know if MS support is present.
hope this info could help

Any chance that Ricoh e230 will be supported?
https://bugs.launchpad.net/ubuntu/+source/linux/+bug/626823

rafael (bomber-man) wrote :

my memory stick reader is not working

ubuntu 10.10

lspci | grep Ricoh

0a:03.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller (rev 05)
0a:03.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22)
0a:03.2 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)

I downloaded the driver, "make", "sudo make install" and "sudo make load"

I attached output from dmesg

It works, friend. Just look at Places menu.
At least kernel log you gave looks perfect.

On Jan 27, 2011 9:21 PM, "rafael" <email address hidden> wrote:

*** This bug is a duplicate of bug 111089 ***
https://bugs.launchpad.net/bugs/111089
my memory stick reader is not working

ubuntu 10.10

lspci | grep Ricoh

0a:03.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller (rev
05)
0a:03.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host
Adapter (rev 22)
0a:03.2 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter
(rev 12)

I downloaded the driver, "make", "sudo make install" and "sudo make
load"

I attached output from dmesg

** Attachment added: "dmesg.log"

https://bugs.launchpad.net/ubuntu/+source/linux/+bug/238208/+attachment/1810886/+files/dmesg.log

--
You received this bug notification because you are a direct subscriber
of the bug.
https://bugs...

rafael (bomber-man) wrote :

> It works, friend. Just look at Places menu.
> At least kernel log you gave looks perfect.

it indeed works, my fault, thanks

Eric Appleman (erappleman) wrote :

The r592 module works.

Michael Marley (mamarley) wrote :

Thanks for writing the MS card driver, but I can't seem to get it to compile. Maybe it doesn't support kernel 2.6.38 yet? Additionally, this bug isn't a duplicate as MS!=MMC.

Here is the error I get:

michael@mamarley-laptop:~/Downloads/ricoh-kernel-ricoh-kernel/memstick$ make
make -C /lib/modules/2.6.38-rc6+/build M=/home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick
make[1]: Entering directory `/home/michael/Downloads/linux-2.6'
  LD /home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick/built-in.o
  LD /home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick/core/built-in.o
  CC [M] /home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick/core/memstick.o
/home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick/core/memstick.c: In function ‘memstick_init’:
/home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick/core/memstick.c:862:2: error: implicit declaration of function ‘create_freezeable_workqueue’ [-Werror=implicit-function-declaration]
/home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick/core/memstick.c:862:12: warning: assignment makes pointer from integer without a cast [enabled by default]
cc1: some warnings being treated as errors

make[3]: *** [/home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick/core/memstick.o] Error 1
make[2]: *** [/home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick/core] Error 2
make[1]: *** [_module_/home/michael/Downloads/ricoh-kernel-ricoh-kernel/memstick] Error 2
make[1]: Leaving directory `/home/michael/Downloads/linux-2.6'
make: *** [build] Error 2

jhoechtl (johann-hoechtl) wrote :

Will this driver help to fix the regression of reading SD cards with Ubuntu 10.10?

07:05.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22)

Was working fine, not any more after 10.10. The above instructions seem to handle Memory Sticks. How to get SD card reading back to live?

Symptoms: Cards are recognized and do automount, but result in a read error.

On Thu, 2011-03-31 at 19:11 +0000, jhoechtl wrote:
> Will this driver help to fix the regression of reading SD cards with
> Ubuntu 10.10?
>
> 07:05.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro
> Host Adapter (rev 22)
>
> Was working fine, not any more after 10.10. The above instructions seem
> to handle Memory Sticks. How to get SD card reading back to live?
>
> Symptoms: Cards are recognized and do automount, but result in a read
> error.
>

10.10 contains 2.6.35, and it since it still uses CONFIG_MMC_RICOH_MMC,
none of my code affects the SD portion.

Which kernel did work?
Did you try with different SD card?

Could you post kernel log?

--
Best regards,
        Maxim Levitsky

Visit my blog: http://maximlevitsky.wordpress.com
Warning: Above blog contains rants.

rafael (bomber-man) wrote :

I upgraded ubuntu and now I'm having the sabe problem as #145

Nishant (nishant-singh28) wrote :

Not working here as well on 11.04, x64,Kernel 2.8.38-8, same problem as #145

I got the driver merged in 2.6.39, so it will appear in next ubuntu version.
(That is minus support for old legacy memorysticks, that while works perfectly, isn't merged because kernel developers pick on minor details of my driver, and I have no time to redone them)

Nishant (nishant-singh28) wrote :

@Maxim: That's awesome news, but do you plan to make it work on 2.6.38? Coz' next Ubuntu release isn't till October.

Michael Marley (mamarley) wrote :

I ended up figuring out the problem I reported up there. There was a difference in spelling of "freezable". After correcting the spelling, it worked fine.

The attachment "r592.tar.bz2" of this bug report has been identified as being a patch. The ubuntu-reviewers team has been subscribed to the bug report so that they can review the patch. In the event that this is in fact not a patch you can resolve this situation by removing the tag 'patch' from the bug report and editing the attachment so that it is not flagged as a patch. Additionally, if you are member of the ubuntu-sponsors please also unsubscribe the team from this bug report.

[This is an automated message performed by a Launchpad user owned by Brian Murray. Please contact him regarding any issues with the action taken in this bug report.]

Michael Marley (mamarley) wrote :

All of the drivers for this chipset are now in the upstream kernel. Can this bug be closed now?

Download full text (3.6 KiB)

Thanks for the email. I'm having a little trouble installing the patch
being a bit of a newbie to ubuntu. Please coul you give me some
direction?

Thanks

----- Original Message -----
From: "Ubuntu QA's Bug Bot" <email address hidden>
To: <email address hidden>
Sent: Sunday, 25 September, 2011 1:08:48 PM
Subject: [Bug 238208]

The attachment "r592.tar.bz2" of this bug report has been identified as
being a patch. The ubuntu-reviewers team has been subscribed to the bug
report so that they can review the patch. In the event that this is in
fact not a patch you can resolve this situation by removing the tag
'patch' from the bug report and editing the attachment so that it is not
flagged as a patch. Additionally, if you are member of the ubuntu-
sponsors please also unsubscribe the team from this bug report.

[This is an automated message performed by a Launchpad user owned by
Brian Murray. Please contact him regarding any issues with the action
taken in this bug report.]

--
You received this bug notification because you are subscribed to the bug
report.
https://bugs.launchpad.net/bugs/238208

Title:
  Need MemoryStick driver Ricoh R5C592 (part of R5C832/822chipset)

Status in The Dell Project:
  Won't Fix
Status in “linux” package in Ubuntu:
  Confirmed
Status in openSUSE:
  New

Bug description:
  *** NOTE: this is a *wishlist* item - a request for new functionality.
  This issue is a request to have MemoryStick support added for a
  specific, and somewhat popular, chipset. Please do not add "me, too"
  items. We know that it doesn't work. If you want, please add
  yourself as a subscriber, and click on link to indicate that "This bug
  effects me, too"

  You are welcome to test the new developed drivers at

  http://gitorious.org/ricoh-kernel

  You can download them ether by doing (preferred):
  git clone git://gitorious.org/ricoh-kernel/ricoh-kernel.git

  Then you can receive updates using
  git pull

  or you can press on 'Source tree' and download a snapshot by pressing
  'Download master as tar.gz'

  XD support is also done and merged in 2.6.35 (backport in above tree)

  ------------------------------------------------

  Running 2.6.24-18, in Hardy

  02:09.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller (rev 05) (prog-if 10 [OHCI])
   Subsystem: Dell Unknown device 022f
   Flags: bus master, medium devsel, latency 64, IRQ 16
   Memory at fe3ff800 (32-bit, non-prefetchable) [size=2K]
   Capabilities: <access denied>

  02:09.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22) (prog-if 01)
   Subsystem: Dell Unknown device 022f
   Flags: medium devsel, IRQ 18
   Memory at fe3ff400 (32-bit, non-prefetchable) [size=256]
   Capabilities: <access denied>

  02:09.2 System peripheral: Ricoh Co Ltd R5C843 MMC Host Controller (rev 12)
   Subsystem: Dell Unknown device 022f
   Flags: bus master, medium devsel, latency 64, IRQ 5
   Memory at fe3ff500 (32-bit, non-prefetchable) [size=256]
   Capabilities: <access denied>

  02:09.3 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)
   Subsystem: Dell Unknown device 022f
   Flags: bus master, medium devsel,...

Read more...

Hamish Darby (judarby) wrote :
Download full text (7.0 KiB)

James

I think the method is to place the folder in places/home, right click and
open with the archive manager
this should detect that it is a software package and handle correctly
Or perhaps do some reading - official documentation or ubuntu forums for the
latest word on the subject
sometimes with Tarballs (fancy zip folder) you need to place it in the
correct place and ubuntu can be hardware specific so don't ask me
I haven't bothered trying it as my wife has that machine, good luck

On 26 September 2011 06:31, James Langdon <email address hidden> wrote:

> Thanks for the email. I'm having a little trouble installing the patch
> being a bit of a newbie to ubuntu. Please coul you give me some
> direction?
>
> Thanks
>
> ----- Original Message -----
> From: "Ubuntu QA's Bug Bot" <email address hidden>
> To: <email address hidden>
> Sent: Sunday, 25 September, 2011 1:08:48 PM
> Subject: [Bug 238208]
>
> The attachment "r592.tar.bz2" of this bug report has been identified as
> being a patch. The ubuntu-reviewers team has been subscribed to the bug
> report so that they can review the patch. In the event that this is in
> fact not a patch you can resolve this situation by removing the tag
> 'patch' from the bug report and editing the attachment so that it is not
> flagged as a patch. Additionally, if you are member of the ubuntu-
> sponsors please also unsubscribe the team from this bug report.
>
> [This is an automated message performed by a Launchpad user owned by
> Brian Murray. Please contact him regarding any issues with the action
> taken in this bug report.]
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/238208
>
> Title:
> Need MemoryStick driver Ricoh R5C592 (part of R5C832/822chipset)
>
> Status in The Dell Project:
> Won't Fix
> Status in “linux” package in Ubuntu:
> Confirmed
> Status in openSUSE:
> New
>
> Bug description:
> *** NOTE: this is a *wishlist* item - a request for new functionality.
> This issue is a request to have MemoryStick support added for a
> specific, and somewhat popular, chipset. Please do not add "me, too"
> items. We know that it doesn't work. If you want, please add
> yourself as a subscriber, and click on link to indicate that "This bug
> effects me, too"
>
> You are welcome to test the new developed drivers at
>
> http://gitorious.org/ricoh-kernel
>
> You can download them ether by doing (preferred):
> git clone git://gitorious.org/ricoh-kernel/ricoh-kernel.git
>
> Then you can receive updates using
> git pull
>
> or you can press on 'Source tree' and download a snapshot by pressing
> 'Download master as tar.gz'
>
>
> XD support is also done and merged in 2.6.35 (backport in above tree)
>
> ------------------------------------------------
>
> Running 2.6.24-18, in Hardy
>
> 02:09.0 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 IEEE 1394 Controller
> (rev 05) (prog-if 10 [OHCI])
> Subsystem: Dell Unknown device 022f
> Flags: bus master, medium devsel, latency 64, IRQ 16
> Memory at fe3ff800 (32-bit, non-prefetchable) [size=2K]
> Capabilities: <access denied>
>
> 02:09.1 SD Host controller: R...

Read more...

The r592.c, driver for MS portion of Ricoh card readers is merged in 2.6.39, so it will appear in ubuntu sooner or later.

The ms_block.c driver for legacy memsticks (128MB and less) is not yet merged, but I doubt you need it.

Also, thanks to Unity, I use kubuntu now, and I exploring possibilities to switch to another distro to have up-to-date KDE.

Hello guys,

I have modified your source Maxim to compile on Kernel 3 and Ubuntu 11.10 (I tested 32 bit only), I have attached the patch here, hope is useful to somebody ! If someone need, I also have a version that compile on Ubuntu 11.04.

For all those with Lenovo T400, the 7.1 reader is not in the Kernel by default, and need to compile and install manually.

As for the original, just unpack anything into a folder, open a terminal and cd into that folder, then:
make
sudo make install
sudo make load

It will then reload automatically at startup.

Cheers guys,
Simone

Excerpt from /boot/config-3.0.0-12-generic on 11.10:

#
# MemoryStick Host Controller Drivers
#
CONFIG_MEMSTICK_TIFM_MS=m
CONFIG_MEMSTICK_JMICRON_38X=m
# CONFIG_MEMSTICK_R592 is not set
CONFIG_NEW_LEDS=y
CONFIG_LEDS_CLASS=y

Any chance of a SRU with that set to =m?

Tim Gardner (timg-tpi) wrote :

SRU Justification

Impact: there is currently no support for MEMSTICK_R592 devices

Patch Description: Enable CONFIG_MEMSTICK_R592 as a module. This should have little chance of regression except on those platforms that support this device, and a mem stick is inserted.

Changed in linux (Ubuntu Oneiric):
assignee: nobody → Tim Gardner (timg-tpi)
status: New → In Progress
Changed in linux (Ubuntu Precise):
assignee: Maxim Levitsky (maximlevitsky) → Tim Gardner (timg-tpi)
status: Confirmed → Fix Committed
Tim Gardner (timg-tpi) on 2011-11-10
Changed in linux (Ubuntu Oneiric):
status: In Progress → Fix Committed
Launchpad Janitor (janitor) wrote :
Download full text (3.4 KiB)

This bug was fixed in the package linux - 3.2.0-1.1

---------------
linux (3.2.0-1.1) precise; urgency=low

  [ Andy Whitcroft ]

  * armhf -- enable armhf and create the first flavours
  * SAUCE: ensure root is ready before running usermodehelpers in it
  * [Config] enforcer -- ensure CONFIG_FAT_FS is built-in on arm

  [ Leann Ogasawara ]

  * Temporarily ignore module check
  * [Config] Enable PCI_IOV on powerpc
  * [Config] Temporarily disable CONFIG_PASEMI_MAC on powerpc
  * rebase to v3.2-rc2
  * SAUCE: include <linux/export.h> for cpuidle34xx arm build
  * SAUCE: include <linux/kernel.h> for linux/mtd/map.h arm build
  * SAUCE: include <linux/printk.h> and <stdarg.h> for mmc_core arm build
  * SAUCE: select ARM_AMBA if OMAP3_EMU
  * [Config] updateconfigs after select ARM_AMBA
  * [Config] Temporarily disable CONFIG_KVM_BOOK3S_32 on powerpc
  * [Config] Enable CONFIG_EXT2_FS=m
  * [Config] Build in CONFIG_SATA_AHCI=y
  * Resolve linux-image-extra's install dependency

  [ Seth Forshee ]

  * [Config] Enable EVENT_POWER_TRACING_DEPRECATED=y for powertop
  * SAUCE: (drop after 3.2) Input: ALPS - move protocol information to
    Documentation
  * SAUCE: (drop after 3.2) Input: ALPS - add protocol version field in
    alps_model_info
  * SAUCE: (drop after 3.2) Input: ALPS - remove assumptions about packet
    size
  * SAUCE: (drop after 3.2) Input: ALPS - add support for protocol versions
    3 and 4
  * SAUCE: (drop after 3.2) Input: ALPS - add semi-MT support for v3
    protocol
  * SAUCE: (drop after 3.2) Input: ALPS - add documentation for protocol
    versions 3 and 4

  [ Stefan Bader ]

  * [Config] Built-in xen-netfront and xen-blkfront
  * Fix build of dm-raid45 and re-enable it

  [ Tim Gardner ]

  * [Config] CONFIG_USB_XHCI_HCD=y
    - LP: #886167
  * [Config] CONFIG_R6040=m
    - LP: #650899
  * SAUCE: Add a new entry (413c:8197) to Bluetooth USB device ID table
    - LP: #854399
  * [Config] Consolidated amd64 server flavour into generic
  * [Config] updateconfigs after rebase to 3.2-rc1
  * [Config] Disabled dm-raid4-5
  * [Config] Disabled ndiswrapper
  * [Config] Disable vt6656
  * [Config] exclude ppp-modules for virtual flavour
  * [Config] CONFIG_MEMSTICK_R592=m
    - LP: #238208

  [ Upstream Kernel Changes ]

  * CHROMIUM: seccomp_filter: new mode with configurable syscall filters
    - LP: #887780
  * CHROMIUM: seccomp_filter: add process state reporting
    - LP: #887780
  * CHROMIUM: seccomp_filter: Document what seccomp_filter is and how it
    works.
    - LP: #887780
  * CHROMIUM: x86: add HAVE_SECCOMP_FILTER and seccomp_execve
    - LP: #887780
  * CHROMIUM: arm: select HAVE_SECCOMP_FILTER
    - LP: #887780
  * CHROMIUM: seccomp_filters: move to btrees
  * CHROMIUM: enable CONFIG_BTREE
  * CHROMIUM: seccomp_filter: kill NR_syscall references
  * CHROMIUM: seccomp_filters: guard all ftrace wrapper code
  * CHROMIUM: seccomp_filters: clean up warnings; kref mistake
  * CHROMIUM: seccomp_filter: remove "skip" from copy and add drop helper
  * CHROMIUM: seccomp_filter: allow CAP_SYS_ADMIN management of execve
  * CHROMIUM: seccomp_filter: inheritance documentation
  * CHROMIUM: seccomp_filter: make inherited filt...

Read more...

Changed in linux (Ubuntu Precise):
status: Fix Committed → Fix Released

SRU was released without this fix...

Changed in linux (Ubuntu Oneiric):
status: Fix Committed → Confirmed
Herton R. Krzesinski (herton) wrote :

This bug is awaiting verification that the kernel for Oneiric in -proposed solves the problem (3.0.0-14.23). Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-oneiric' to 'verification-done-oneiric'.

If verification is not done by one week from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-oneiric

Updated the Kernel, my cards are all there !!! I can confirm that it works so far.

Tim Gardner (timg-tpi) on 2011-11-25
tags: added: verification-done-oneiric
removed: verification-needed-oneiric
Changed in linux (Ubuntu Oneiric):
status: Confirmed → Fix Committed

The kernel in -proposed does NOT work. With the 3.0.0-12 kernel and the patch posted earlier, it worked. With the stock 3.0.0-14, it does not detect the MSPro card at all unless the card is already inserted before the module is probed. If the card is removed, nothing works until the module is unloaded and reloaded with a card already in the reader.

Changed in linux (Ubuntu Oneiric):
status: Fix Committed → Confirmed
Launchpad Janitor (janitor) wrote :
Download full text (24.8 KiB)

This bug was fixed in the package linux - 3.0.0-14.23

---------------
linux (3.0.0-14.23) oneiric-proposed; urgency=low

  [Herton R. Krzesinski]

  * Release Tracking Bug
    - LP: #893213

  [ Andy Whitcroft ]

  * debian: add locking to protect debian/files from parallel update

  [ Konrad Rzeszutek Wilk ]

  * SAUCE: x86/paravirt: Partially revert "remove lazy mode in interrupts"
    - LP: #854050

  [ Leann Ogasawara ]

  * Revert "ubuntu: fsam7400 disable driver"
    - LP: #876030

  [ Seth Forshee ]

  * [Config] Enable EVENT_POWER_TRACING_DEPRECATED=y for powertop

  [ Tim Gardner ]

  * Add postinit and postrm scripts to the extras package
    - LP: #882120
  * [Config] CONFIG_R6040=m
    - LP: #650899
  * [Config] CONFIG_MEMSTICK_R592=m
    - LP: #238208
  * [Config] CONFIG_HID_ACRUX_FF=y
    - LP: #890952

  [ Upstream Kernel Changes ]

  * Revert "NFS: Ensure that writeback_single_inode() calls write_inode()
    when syncing"
    - LP: #890952
  * sparc64: Force the execute bit in OpenFirmware's translation entries.
    - LP: #881420
  * sched/rt: Migrate equal priority tasks to available CPUs
    - LP: #881420
  * sched: Fix up wchan borkage
    - LP: #881420
  * ide-disk: Fix request requeuing
    - LP: #881420
  * posix-cpu-timers: Cure SMP wobbles
    - LP: #881420
  * lis3: fix regression of HP DriveGuard with 8bit chip
    - LP: #881420
  * ASoC: use a valid device for dev_err() in Zylonite
    - LP: #881420
  * ASoC: Fix setting update bits for WM8753_LADC and WM8753_RADC
    - LP: #881420
  * drm/radeon: Update AVIVO cursor coordinate origin before x/yorigin
    calculation.
    - LP: #881420
  * drm/radeon/kms: fix regression in DP aux defer handling
    - LP: #881420
  * drm/radeon/kms: add retry limits for native DP aux defer
    - LP: #881420
  * drm/radeon/kms: fix channel_remap setup (v2)
    - LP: #881420
  * ptp: fix L2 event message recognition
    - LP: #881420
  * x86/PCI: use host bridge _CRS info on ASUS M2V-MX SE
    - LP: #881420
  * qla2xxx: Fix crash in qla2x00_abort_all_cmds() on unload
    - LP: #881420
  * libsas: fix panic when single phy is disabled on a wide port
    - LP: #881420
  * md: Avoid waking up a thread after it has been freed.
    - LP: #881420
  * dm table: avoid crash if integrity profile changes
    - LP: #881420
  * mmc: mxs-mmc: fix clock rate setting
    - LP: #881420
  * exec: do not call request_module() twice from search_binary_handler()
    - LP: #881420
  * ARM: mach-ux500: enable fix for ARM errata 754322
    - LP: #881420
  * drm/radeon/kms: retry aux transactions if there are status flags
    - LP: #881420
  * drm/radeon/kms: use hardcoded dig encoder to transmitter mapping for
    DCE4.1
    - LP: #881420
  * ipv6: fix NULL dereference in udp6_ufo_fragment()
    - LP: #881420
  * ahci: Enable SB600 64bit DMA on Asus M3A
    - LP: #881420
  * MIPS: PM: Use struct syscore_ops instead of sysdevs for PM (v2)
    - LP: #881420
  * ftrace: Fix regression of :mod:module function enabling
    - LP: #881420
  * ftrace: Fix regression where ftrace breaks when modules are loaded
    - LP: #881420
  * ftrace: Fix warning when CONFIG_FUNCTION_TRACER is not defined
    - LP: #881420
  * ...

Changed in linux (Ubuntu Oneiric):
status: Confirmed → Fix Released

This bug is NOT fixed in Oneiric. Why is it marked "Fix Released" now?

tags: added: verification-failed-oneiric
removed: verification-done-oneiric
Brad Figg (brad-figg) wrote :

@daniel

The patch enabled the CONFIG_MEMSTICK_R592 kernel config parameter. I can confirm that it is enabled in the 3.0.0-14 kernel that I have installed which is the one from -proposed. It looks like this fix worked for at leas one person (see comment #165). Even if this change does not fix everyones issue I believe that it does for some.

Brad Figg (brad-figg) wrote :

@daniel,

There is quite a bit of variation in the SD cards from different vendors. Have you tried cards from different vendors and do they all fail?

SD cards work fine. My M2 card in the MSPro adapter works fine with
the patch posted above, but with the new kernel, there is the
aforementioned problem requiring removing and reinserting the module
every time to get it to work correctly.

Ahmet Öztürk (dmxe) wrote :

in my system it just works now after the latest kernel updates.
card: memory stick pro duo 2gb
computer: dell xps m1330
kernel: 3.0.0-14-generic

Alex Mayorga (alex-mayorga) wrote :

Memory Stick PRO Duo cards are still not being auto-mounted when inserted on the following configuration in 12.04.

What needs to be done for this to "just work"?

alex-mayorga@VPCCW1FFXL:~$ lspci | grep Ricoh
04:00.0 SD Host controller: Ricoh Co Ltd MMC/SD Host Controller
04:00.1 System peripheral: Ricoh Co Ltd Memory Stick Host Controller
04:00.3 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 PCIe IEEE 1394 Controller
04:00.4 SD Host controller: Ricoh Co Ltd MMC/SD Host Controller

alex-mayorga@VPCCW1FFXL:~$ uname -a
Linux VPCCW1FFXL 3.2.0-23-generic #36-Ubuntu SMP Tue Apr 10 20:39:51 UTC 2012 x86_64 x86_64 x86_64 GNU/Linux

Snippet from /boot/config-3.2.0-23-generic

#
# MemoryStick drivers
#
# CONFIG_MEMSTICK_UNSAFE_RESUME is not set
CONFIG_MSPRO_BLOCK=m

#
# MemoryStick Host Controller Drivers
#
CONFIG_MEMSTICK_TIFM_MS=m
CONFIG_MEMSTICK_JMICRON_38X=m
CONFIG_MEMSTICK_R592=m
CONFIG_NEW_LEDS=y
CONFIG_LEDS_CLASS=y

sdowney717 (sdowney717) wrote :

it apparently affects me. I just tried inserting a SDHC 8gb card and it is not recognized.
dmesg errors
[53801.487087] mmcblk0: error -84 transferring data, sector 6, nr 2, cmd response 0x900, card status 0x0
[53801.487091] end_request: I/O error, dev mmcblk0, sector 6
[53801.487874] mmcblk0: error -84 transferring data, sector 7, nr 1, cmd response 0x900, card status 0x0
[53801.487878] end_request: I/O error, dev mmcblk0, sector 7

lspci
06:06.1 SD Host controller: Ricoh Co Ltd R5C822 SD/SDIO/MMC/MS/MSPro Host Adapter (rev 22)
06:06.2 System peripheral: Ricoh Co Ltd R5C592 Memory Stick Bus Host Adapter (rev 12)
06:06.3 System peripheral: Ricoh Co Ltd xD-Picture Card Controller (rev 12)

Norbert (nrbrtx) wrote :
Download full text (4.6 KiB)

I have VAIO F13Z1R with SD and MS (label Magic Gate, HG Duo) card readers with Ubuntu 12.04 LTS on it.

My lspci is:
lspci
00:00.0 Host bridge: Intel Corporation Core Processor DMI (rev 11)
00:03.0 PCI bridge: Intel Corporation Core Processor PCI Express Root Port 1 (rev 11)
00:08.0 System peripheral: Intel Corporation Core Processor System Management Registers (rev 11)
00:08.1 System peripheral: Intel Corporation Core Processor Semaphore and Scratchpad Registers (rev 11)
00:08.2 System peripheral: Intel Corporation Core Processor System Control and Status Registers (rev 11)
00:08.3 System peripheral: Intel Corporation Core Processor Miscellaneous Registers (rev 11)
00:10.0 System peripheral: Intel Corporation Core Processor QPI Link (rev 11)
00:10.1 System peripheral: Intel Corporation Core Processor QPI Routing and Protocol Registers (rev 11)
00:1a.0 USB controller: Intel Corporation 5 Series/3400 Series Chipset USB2 Enhanced Host Controller (rev 05)
00:1b.0 Audio device: Intel Corporation 5 Series/3400 Series Chipset High Definition Audio (rev 05)
00:1c.0 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 1 (rev 05)
00:1c.1 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 2 (rev 05)
00:1c.2 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 3 (rev 05)
00:1c.5 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 6 (rev 05)
00:1c.6 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 7 (rev 05)
00:1d.0 USB controller: Intel Corporation 5 Series/3400 Series Chipset USB2 Enhanced Host Controller (rev 05)
00:1e.0 PCI bridge: Intel Corporation 82801 Mobile PCI Bridge (rev a5)
00:1f.0 ISA bridge: Intel Corporation Mobile 5 Series Chipset LPC Interface Controller (rev 05)
00:1f.2 SATA controller: Intel Corporation 5 Series/3400 Series Chipset 6 port SATA AHCI Controller (rev 05)
00:1f.3 SMBus: Intel Corporation 5 Series/3400 Series Chipset SMBus Controller (rev 05)
01:00.0 VGA compatible controller: NVIDIA Corporation GF108 [GeForce GT 425M] (rev a1)
01:00.1 Audio device: NVIDIA Corporation GF108 High Definition Audio Controller (rev a1)
02:00.0 Network controller: Atheros Communications Inc. AR9287 Wireless Network Adapter (PCI-Express) (rev 01)
03:00.0 SD Host controller: Ricoh Co Ltd MMC/SD Host Controller
03:00.1 System peripheral: Ricoh Co Ltd Memory Stick Host Controller
03:00.3 FireWire (IEEE 1394): Ricoh Co Ltd R5C832 PCIe IEEE 1394 Controller
03:00.4 SD Host controller: Ricoh Co Ltd MMC/SD Host Controller
04:00.0 Ethernet controller: Marvell Technology Group Ltd. 88E8057 PCI-E Gigabit Ethernet Controller (rev 10)
05:00.0 USB controller: NEC Corporation uPD720200 USB 3.0 Host Controller (rev 03)
3f:00.0 Host bridge: Intel Corporation Core Processor QuickPath Architecture Generic Non-Core Registers (rev 04)
3f:00.1 Host bridge: Intel Corporation Core Processor QuickPath Architecture System Address Decoder (rev 04)
3f:02.0 Host bridge: Intel Corporation Core Processor QPI Link 0 (rev 04)
3f:02.1 Host bridge: Intel Corporation Core Processor QPI Physical 0 (rev 04)
3f:03.0 Host bridge: Intel Corpo...

Read more...

Norbert (nrbrtx) wrote :

SD cardreader works, of course.

Changed in somerville:
importance: Undecided → Wishlist
status: New → Won't Fix
no longer affects: dell

The bug task for the somerville project has been removed by an automated script. This bug has been cloned on that project and is available here: https://bugs.launchpad.net/bugs/1305706

no longer affects: somerville
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers